import sys, re
import numpy as np
import sklearn.cluster

predictions_file = sys.argv[1]
answers_file = sys.argv[2]

f = open(answers_file)
f2 = open(predictions_file)
f.readline()
f2.readline()
trues = []
preds = []
base_trues = []
base_preds = []
events_trues = []
events_preds = []
for line in f:
	line2 = f2.readline()
	split1 = line.split("\t")
	split2 = line2.split(",")	
	base_true = float(split1[4])
	events_true = split1[5:-1]
	for i in xrange(len(events_true)):
		events_true[i] = float(events_true[i].split(",")[-1])
	#print "base_true=", base_true
	#print "events_true=", events_true
	base_pred = float(re.search(r'N\((.*?);', split2[5]).group(1))
	events_pred = split2[6].split("|")[:-1]
	for i in xrange(len(events_pred)):
		#print
		print events_pred[i]
		events_pred[i] = float(re.search(r' N\((.*?);', events_pred[i]).group(1))
	#print "base_pred=", base_pred
	#print "events_pred=", events_pred
	#print
	
	trues.append(base_true)
	base_trues.append(base_true)
	for e in events_true:
		trues.append(e)
		events_trues.append(e)
	preds.append(base_pred)	
	base_preds.append(base_pred)
	for e in events_pred:
		preds.append(e)
		events_preds.append(e)
f.close()
f2.close()

preds = np.array(preds)
trues = np.array(trues)
print "GLOBAL ERRORS:"
print "corr=", np.corrcoef(preds, trues)[0,1]
print "mae=", np.sum(np.abs(trues - preds)) / len(trues)
print "rmse=", np.sqrt(np.sum((trues - preds)**2) / len(trues))
print "rae=", np.sum(np.abs(trues - preds)) / np.sum(np.abs(trues - np.mean(trues)))
print "rrse=", np.sqrt(np.sum((trues - preds)**2) / np.sum((trues - np.mean(trues))**2))
print

preds = np.array(base_preds)
trues = np.array(base_trues)
print "BASE ERRORS:"
print "corr=", np.corrcoef(preds, trues)[0,1]
print "mae=", np.sum(np.abs(trues - preds)) / len(trues)
print "rmse=", np.sqrt(np.sum((trues - preds)**2) / len(trues))
print "rae=", np.sum(np.abs(trues - preds)) / np.sum(np.abs(trues - np.mean(trues)))
print "rrse=", np.sqrt(np.sum((trues - preds)**2) / np.sum((trues - np.mean(trues))**2))
print

preds = np.array(events_preds)
trues = np.array(events_trues)
print "EVENTS ERRORS:"
print "corr=", np.corrcoef(preds, trues)[0,1]
print "mae=", np.sum(np.abs(trues - preds)) / len(trues)
print "rmse=", np.sqrt(np.sum((trues - preds)**2) / len(trues))
print "rae=", np.sum(np.abs(trues - preds)) / np.sum(np.abs(trues - np.mean(trues)))
print "rrse=", np.sqrt(np.sum((trues - preds)**2) / np.sum((trues - np.mean(trues))**2))
print
